
class SubsetEnumerator implements java.util.Set
{
  private Object[] elements;
  private boolean[] in;

  protected class CurrentSetIterator implements java.util.Iterator
  {
    int _current;
    int _next;

    public CurrentSetIterator()
    {
      int i = 0;
      while ((i < in.length) && !in[i]) i += 1;
      _current = i++;
      while ((i < in.length) && !in[i]) i += 1;
      _next = i;
    }

    public boolean hasNext()
    {
      return (_current < in.length);
    }

    public Object next()
    {
      int p = _current;
      _current = _next;
      _next += 1;
      while ((_next < in.length) && !in[_next]) _next += 1;
      return (elements[p]);
    }

    public void remove() throws UnsupportedOperationException
    {
      throw new UnsupportedOperationException();
    }
  }

  public SubsetEnumerator(Object[] es)
  {
    elements = es;
    in = new boolean[elements.length];
  }

  public SubsetEnumerator(java.util.Set es)
  {
    elements = es.toArray();
    in = new boolean[elements.length];
  }

  public boolean first()
  {
    for (int i = 0; i < in.length; i++) in[i] = false;
    return true;
  }

  public boolean next()
  {
    int n = in.length;
    int p = 0;
    while ((p < n) && in[p]) p += 1;
    if (p < n) {
      for (int i = 0; i < p; i++) in[i] = false;
      in[p] = true;
      return true;
    }
    else {
      return false;
    }
  }

  public boolean first(int m)
  {
    int n = in.length;
    if (m > n) return false;
    for (int k = 0; (k < m) && (k < n); k++) in[k] = true;
    for (int k = m; k < n; k++) in[k] = false;
    return true;
  }

  public boolean next(int m)
  {
    int n = in.length;
    if ((m == 0) || (n == 0) || (m == n)) return false;
    if (!in[n - 1]) {
      int p = n - 1;
      while (!in[p]) p -= 1;
      // assert(in[p]);
      in[p] = false;
      in[p + 1] = true;
      return true;
    }
    else {
      int p_last_out = n - 1;
      while (in[p_last_out] && (p_last_out > 0)) p_last_out -= 1;
      // assert(!in[p_last_out]);
      int p_next_in = p_last_out;
      while (!in[p_next_in] && (p_next_in > 0)) p_next_in -= 1;
      if (!in[p_next_in]) return false;
      int n_rem_in = n - p_last_out;
      in[p_next_in] = false;
      for (int k = 0; k < n_rem_in; k++) in[p_next_in + k + 1] = true;
      for (int k = p_next_in + n_rem_in + 1; k < n; k++) in[k] = false;
      return true;
    }
  }

  public boolean contains(Object o)
  {
    for (int i = 0; i < elements.length; i++)
      if (in[i])
	if (elements[i].equals(o))
	  return true;
    return false;
  }

  public boolean containsAll(java.util.Collection c)
  {
    java.util.Iterator i = c.iterator();
    while (i.hasNext()) {
      if (!contains(i.next()))
	return false;
    }
    return true;
  }

  public boolean equals(Object o)
  {
    try {
      SubsetEnumerator s = (SubsetEnumerator)o;
      if (s.elements.length != elements.length)
	return false;
      for (int i = 0; i < elements.length; i++)
	if (!elements.equals(s.elements[i]) || (in[i] != s.in[i]))
	  return false;
      return true;
    }
    catch (Exception e) {
      return false;
    }
  }

  public int hashCode()
  {
    int h = 0;
    for (int i = 0; i < elements.length; i++)
      h += elements[i].hashCode();
    return h;
  }

  public boolean isEmpty()
  {
    for (int i = 0; i < elements.length; i++)
      if (in[i]) return false;
    return true;
  }

  public java.util.Iterator iterator()
  {
    return new CurrentSetIterator();
  }

  public int size()
  {
    int n = 0;
    for (int i = 0; i < elements.length; i++)
      if (in[i]) n += 1;
    return n;
  }

  public Object[] toArray()
  {
    int n = size();
    Object[] a = new Object[n];
    int p = 0;
    for (int i = 0; i < elements.length; i++)
      if (in[i]) a[p++] = elements[i];
    return a;
  }

  public Object[] toArray(Object[] a)
  {
    return toArray();
  }


  // unsupported stuff

  public boolean add(Object o)
    throws UnsupportedOperationException
  {
    throw new UnsupportedOperationException();
  }

  public boolean addAll(java.util.Collection c)
    throws UnsupportedOperationException
  {
    throw new UnsupportedOperationException();
  }

  public void clear()
    throws UnsupportedOperationException
  {
    throw new UnsupportedOperationException();
  }

  public boolean remove(Object o)
    throws UnsupportedOperationException
  {
    throw new UnsupportedOperationException();
  }

  public boolean removeAll(java.util.Collection c)
    throws UnsupportedOperationException
  {
    throw new UnsupportedOperationException();
  }

  public boolean retainAll(java.util.Collection c)
    throws UnsupportedOperationException
  {
    throw new UnsupportedOperationException();
  }

}
